--- 0001-Ajout-premi-re-version-de-l-article-Rawhide.patch	2015-12-08 10:06:33.840773801 +0100
+++ 0002-Ajout-premi-re-version-de-l-article-Rawhide.patch	2015-12-11 09:37:18.624501484 +0100
@@ -18,42 +18,40 @@
 --- /dev/null
 +++ b/articles/Rawhide.md
 @@ -0,0 +1,57 @@
-+# Présentation de Rawhide, son intérêt, son fonctionnement, ses risques
++# Présentation de _Fedora Rawhide_: son fonctionnement, son intérêt, ses risques
 +
 +## Un système en perpétuelle évolution
 +
-+_Fedora Rawhide_ est le nom donné par le projet comme la version de la distribution en développement éternel. Ce concept pourrait être à rapprocher de celui de _Debian Sid_ pour la distribution éponyme par exemple.
-+Cependant, la réalité reste un peu plus complexe que cela, nous allons étudier pour cela un petit peu comment une version de Fedora est élaborée.
++_Fedora Rawhide_ est le nom donné par le projet à la version de la distribution en développement éternel. Ce concept pourrait être rapproché de celui de _Debian Sid_ pour la distribution éponyme par exemple.
++Cependant, la réalité reste un peu plus complexe que cela. C'est pourquoi nous allons étudier un petit peu comment une version de Fedora est élaborée.
 +
-+À l'heure actuelle la dernière version stable est Fedora 23, sortie le 3 novembre 2015. À ce stade, la prochaine version, la 24 prévue pour mai 2016, n'est pas très avancée en terme de développement. Donc nous avons en guise de version de développement seulement Fedora Rawhide qui est disponible.
-+
-+Cependant, plus tard dans le cycle à l'approche de la première Alpha de Fedora 24, vers février 2016, il y aura une scission. Fedora Rawhide ne sera plus la seule version en développement, Fedora 24 sera séparée de cette dernière. L'objectif est que Fedora 24 se stabilise, certains composants seront figés plus ou moins définitivement. Quant à Fedora Rawhide, il continuera son bonhomme de chemin, acceptant les mises à jour comme personne. En ce sens, Fedora Rawhide ne sera jamais stabilisée, mais toutes les versions stables de Fedora se basent à un moment donné sur elle pour évoluer.
++Actuellement, la dernière version stable est _Fedora 23_, sortie le 3 novembre 2015. À ce stade, la prochaine version stable, _Fedora 24_, est prévue pour mai 2016,et n'est pas très avancée sur le plan du développement. Nous avons donc uniquement Fedora Rawhide en guise de version de développement. Cependant, vers février 2016, il y aura une scission suite à l'approche de la première Alpha de Fedora 24: Fedora 24 sera séparée de Fedora Rawide. Cette dernière ne sera donc plus la seule version en développement, et ce, jusqu'à l'arrivée de la version stable de Fedora 24. L'objectif des versions en développement de Fedora24 est que celle-ci se stabilise, et certains composants seront figés plus ou moins définitivement. Quant à Fedora Rawhide, il continuera son bonhomme de chemin, acceptant les mises à jour comme personne. En ce sens, Fedora Rawhide ne sera jamais stabilisée, contrairement aux autres versions (stables) de Fedora, bien que toutes ces versions de Fedora se basent à un moment donné sur elle pour évoluer.
 +
 +## Son intérêt
 +
-+Le concept peut paraître au premier abord très étrange. Pourquoi maintenir par moment deux versions en développement de Fedora en même temps ? Pourquoi n'enchainons nous pas réellement directement deux versions stables de Fedora ?
++Le concept peut paraître au premier abord très étrange. Pourquoi maintenir par moment deux versions en développement de Fedora en même temps ? Pourquoi n'enchainons nous pas directement deux versions stables de Fedora?
 +
-+En premier lieu, il faut comprendre que dans la vie d'une distribution : plus les mises à jours sont petites et régulières, plus le résultat est fiable. Ces évolutions incrémentales sont l'essence même de Rawhide, qui peut être vue à cet égard comme une distribution dite _rolling release_. Comme cela a été expliqué précédemment, durant la phase de stabilisation d'une version donnée certains composants sont figés. Après plusieurs mois de « gel » de ces composants, si nous devions rattrapper le retard pris pour chacun d'entre eux, la mise à niveau dans le cycle de développement serait énorme. Fedora Rawhide évoluera régulièrement pendant ces mois là ce qui évite ces ruptures dans le développement.
++En premier lieu, il faut comprendre que, dans la vie d'une distribution, plus les mises à jours sont petites et régulières, plus le résultat est fiable. Ces évolutions incrémentales sont l'essence même de Fedora Rawhide, qui peut être vue à cet égard comme une distribution dite _rolling release_ (c'est-à-dire comme une version en développement continu). Comme cela a été expliqué précédemment, certains composants sont figés durant la phase de stabilisation d'une version donnée. Après plusieurs mois de « gel » de ces composants, si nous devions rattrapper le retard pris pour chacun d'entre eux, la mise à niveau dans le cycle de développement serait énorme. Fedora Rawhide évoluera régulièrement pendant ces mois-là, évitant ainsi ces ruptures dans le développement des versions stables.
 +
-+Ensuite, il ne faut pas oublier que le projet Fedora évolue constamment. Il y a sans cesse des choses à développer ou mettre à jour puis tester. Fedora Rawhide étant séparée durant la phase de stabilisation, mais toujours existante, les développeurs peuvent continuer durant ce temps les expérimentations sans nuire à la fiabilisation du produit. Rawhide peut même aider à tester un composant avant de l'inclure dans les versions stables après coup !
++Ensuite, il ne faut pas oublier que le projet Fedora évolue constamment. Il y a sans cesse des choses à développer, ou à mettre à jour, et ensuite à tester. Fedora Rawhide étant séparée durant la phase de stabilisation, mais toujours existante, les développeurs peuvent continuer durant ce temps les expérimentations sans nuire à la fiabilisation du produit. Fedora Rawhide peut même aider à tester un composant avant de l'inclure dans les versions stables !
 +
-+Vous n'êtes toujours pas convaincus ? Pour les amateurs de sensation fortes et qui n'aiment pas ces gels pour fiabiliser, ou le fait de réaliser des mises à niveau tous les six mois en moyennes, Fedora Rawhide peut sembler être une belle promesse.
++Vous n'êtes toujours pas convaincus ? Pour les amateurs de sensations fortes et qui n'aiment pas ces gels nécessaires pour la fiabilisation, ou le fait de réaliser des mises à niveau tous les six mois en moyenne, Fedora Rawhide peut sembler être une belle promesse.
 +
-+## Ses différences… et ses risques !
++## Ses différences… et ses risques!
 +
-+Utiliser Fedora Rawhide, ce n'est pas strictement identique à utiliser une autre version de la distribution.
-+De part les éléments déjà cités, il semble évident que Fedora Rawhide est une version pour développer et tester des choses nouvelles. Cela va avoir des impacts sur les logiciels fournis. Typiquement, nombre d'entre eux sont fournis en version de _débogue_. C'est-à-dire qu'ils contiennent des éléments supplémentaires pour simplifier la recherche d'un problème au détriment des performances. C'est le cas par exemple du _noyau Linux_.
++L'utilisation de Fedora Rawhide n'est pas strictement identique à l'utilisation d'une autre version de la distribution.
++De part les éléments déjà cités, il semble évident que Fedora Rawhide est une version pour développer et tester des choses nouvelles. Cela va donc avoir des impacts sur les logiciels fournis. Typiquement, nombre d'entre eux sont fournis en version de _débogue_, c'est-à-dire qu'ils contiennent des éléments supplémentaires pour simplifier la recherche d'un problème au détriment des performances. C'est par exemple le cas du _noyau Linux_.
 +
-+C'est également une version à part en terme de gestion des dépôts. Il est possible que les dépôts externes tels que RPMFusion ou des dépôts personnalisés à base de Copr ne soient pas supportés. Il est donc préférable de vérifier la disponibilité des paquets externes avant de s'y lancer !
-+Sans oublier que de part sa nature instable, il n'y a pas le mécanisme de dépôts _update-testing_. C'est-à-dire que n'importe quelle mise à jour est directement disponible dans les dépôts de Rawhide. Pour les versions plus stable, d'habitude un paquet est transféré pendant quelques jours et semaines dans le dépôt _update-testing_ pour s'assurer du bon fonctionnement du paquet. Il y a donc plus de risques d'avoir un paquet cassé.
++Fedora Rawhide est également une version à part en termes de gestion des dépôts. Il est possible que les dépôts externes, tels que RPMFusion ou des dépôts personnalisés à base de Copr, ne soient pas supportés. Il est donc préférable de vérifier la disponibilité des paquets externes avant de s'y lancer !
++Sans oublier que de part sa nature instable, il n'y a pas le mécanisme de dépôts _update-testing_. En effet, pour les versions  en voie de stabilisation, ou stables, un paquet est habituellement premièrement transféré pendant quelques jours, voire quelques semaines, dans le dépôt _update-testing_ afin de s'assurer de son bon fonctionnement. Suite à l'absence de ce mécanisme pour Fedora Rawhide, n'importe quelle mise à jour est directement disponible dans ses dépôts, augmentent le risque d'avoir un paquet cassé. 
 +
-+Cependant, un grand effort a été fait en terme d'assurance qualité pour limiter ce risque ces dernières années et un effort futur semble se mettre en place pour favoriser l'usage de Fedora Rawhide comme version au quotidien.
++Cependant, ces dernières années, un grand effort a été fait en termes d'assurance qualité pour limiter ce risque, et un effort futur semble se mettre en place pour favoriser l'usage de Fedora Rawhide comme version au quotidien.
 +
-+Vous l'aurez compris, passer à ce système présente des risques. C'est pourquoi il est recommandé de faire un test en machine virtuelle avant d'envisager le grand saut. Puis, toujours faire attention et suivre avec attention aux listes de diffusion _devel@lists.fedoraproject.org_ et _test@lists.fedoraproject.org_.
++Vous l'aurez compris, passer à ce système présente des risques. C'est pourquoi il est recommandé de faire un test en machine virtuelle avant d'envisager le grand saut, ainsi que de toujours suivre avec attention les listes de diffusion _devel@lists.fedoraproject.org_ et _test@lists.fedoraproject.org_.
 +
-+## Comment l'installer ?
++## Comment l'installer?
 +
-+Si vous êtes intéressés par l'installation de Fedora Rawhide (et que vous savez ce que vous faites), sachez qu'il existe des images compilées chaque nuit pour l'installer en toute circonstance. L'installation se fait par le réseau pour s'assurer d'avoir les derniers paquets disponibles. Vous pouvez la [télécharger (image pour systèmes x86_64)](download.fedoraproject.org/pub/fedora/linux/development/rawhide/x86_64/os/images/boot.iso) et [l'installer](http://doc.fedora-fr.org/wiki/Netinstall_de_Fedora) de façon similaire à une version stable de Fedora.
++Si vous êtes intéressés par l'installation de Fedora Rawhide (et que vous savez ce que vous faites), sachez qu'il existe des images compilées chaque nuit pour l'installer en toutes circonstances. L'installation se fait par le réseau pour s'assurer d'avoir les derniers paquets disponibles. Vous pouvez la [télécharger (image pour systèmes x86_64)](download.fedoraproject.org/pub/fedora/linux/development/rawhide/x86_64/os/images/boot.iso) et [l'installer](http://doc.fedora-fr.org/wiki/Netinstall_de_Fedora) de façon similaire à une version stable de Fedora.
 +
 +Si jamais vous avez une Fedora stable et que vous souhaitez la mettre à niveau, vous pouvez procéder ainsi en console (avec les droits superutilisateurs) :
 +
@@ -63,17 +61,17 @@
 +# dnf system-upgrade reboot
 +```
 +
-+Au redémarrage, le système se mettra à jour vers Rawhide.
++Au redémarrage, le système se mettra à jour vers Fedora Rawhide.
 +
-+## Et maintenant, que faire ?
++## Et maintenant, que faire?
 +
 +Fedora Rawhide reste une version de tests et le moindre retour sur son fonctionnement est considéré comme précieux. L'objectif est de rapporter un maximum de problèmes que vous rencontrez pour aider à stabiliser cette version au maximum et la rendre plus utilisable pour tous.
 +
 +Il est donc recommandé [d'apprendre et faire un rapport de bogue](http://doc.fedora-fr.org/wiki/Apprendre_%C3%A0_rapporter_un_bogue) pour commencer. La participation à des initiatives d'assurance qualité est également un plus important pour le projet comme [le test automatisé du noyau Linux](https://fedoraproject.org/wiki/KernelTestingInitiative).
 +
-+Bien évidemment, faire des sauvegardes régulièrement et savoir se débrouiller en cas de problèmes sont également des plus. Le forum fedora-fr propose [un espace d'échange](http://forums.fedora-fr.org/viewforum.php?id=116) autour de Fedora Rawhide pour dépanner les problèmes. Ne pas hésiter à aller dessus en cas de pépins.
++Bien évidemment, faire des sauvegardes régulièrement et savoir se débrouiller en cas de problèmes sont également des avantages. Le forum fedora-fr propose [un espace d'échange](http://forums.fedora-fr.org/viewforum.php?id=116) autour de Fedora Rawhide pour dépanner en cas de problèmes. N'hésitez à aller dessus en cas de pépins.
 +
-+Maintenant, vous pouvez utiliser Fedora Rawhide et faire vos retours sur son fonctionnement afin d'améliorer encore et toujours les versions stables. Les utilisateurs et développeurs du projet vous remercieront pour votre investissement. Et pensez à mettre à jour votre système fréquemment.
++Maintenant, vous pouvez utiliser Fedora Rawhide et faire vos retours sur son fonctionnement afin d'améliorer encore et toujours les versions stables. Les utilisateurs et développeurs du projet vous remercieront pour votre investissement. Et n'oubliez pas de mettre à jour votre système fréquemment.
 +
 -- 
 2.5.0