From 0c8b7ffd9d121894cdbcb04054c1d4377c456b4d Mon Sep 17 00:00:00 2001
From: Sinny Kumari <sinny@redhat.com>
Date: Thu, 25 Oct 2018 20:57:37 +0530
Subject: [PATCH] Include updates-testing repo during bodhi u-t run

Latest dnf available in F29 solves the lorax issue while
using multiple repos - https://github.com/weldr/lorax/issues/368
Including updates-testing repo will help us to test latest fixes
done in packages which composes AH ISO.
---
 roles/bodhi2/backend/templates/pungi.rpm.conf.j2 | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

diff --git a/roles/bodhi2/backend/templates/pungi.rpm.conf.j2 b/roles/bodhi2/backend/templates/pungi.rpm.conf.j2
index af3f5ea29..b35d346a3 100644
--- a/roles/bodhi2/backend/templates/pungi.rpm.conf.j2
+++ b/roles/bodhi2/backend/templates/pungi.rpm.conf.j2
@@ -301,7 +301,12 @@ ostree_installer = [
                     #   [% endif %]
                     # For f29 the compose location is under /compose/branched/
                     [% if release.version_int == 29 %]
-                        "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/branched/latest-Fedora-[[ release.version_int ]]/compose/Everything/[[arch]]/os/"
+                        "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/branched/latest-Fedora-[[ release.version_int ]]/compose/Everything/[[arch]]/os/",
+                        [% if request.name == 'testing' %]
+                            # In the case of testing, also inject updates-testing repo.
+                            # https://github.com/weldr/lorax/issues/368 is fixed in >= f29
+                            "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/updates/f[[ release.version_int ]]-updates-testing/compose/Everything/[[arch]]/os/"
+                        [% endif %]
                     [% else %]
                         "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/[[ release.version_int ]]/latest-Fedora-[[ release.version_int ]]/compose/Everything/[[arch]]/os/"
                     [% endif %]
-- 
2.17.2