From 06a4940df01db0ae37a50f133895de19cc2b9a3a Mon Sep 17 00:00:00 2001
From: Sinny Kumari <sinny@redhat.com>
Date: Thu, 25 Oct 2018 20:57:37 +0530
Subject: [PATCH] Include multiple repos for AH ISO and update F29 repos

* Latest dnf available in F29 solves the lorax issue while
  using multiple repos - https://github.com/weldr/lorax/issues/368
  Including latest updates and updates-testing repo will help us to
  test latest fixes done in packages which composes AH ISO.
* With F29 RC 1.2 declared Gold, update Atomic Host repo for OSTree
  and artifacts creation from /compose/branched/ to compose/29/
* With F29 RC 1.2 declared Gold, update Silverblue repo for OSTree
  creation from /compose/branched/ to compose/29/
---
 .../backend/templates/pungi.rpm.conf.j2       | 32 +++++++++----------
 1 file changed, 15 insertions(+), 17 deletions(-)

diff --git a/roles/bodhi2/backend/templates/pungi.rpm.conf.j2 b/roles/bodhi2/backend/templates/pungi.rpm.conf.j2
index af3f5ea29..76e8ffda8 100644
--- a/roles/bodhi2/backend/templates/pungi.rpm.conf.j2
+++ b/roles/bodhi2/backend/templates/pungi.rpm.conf.j2
@@ -130,8 +130,8 @@ ostree = {
                     # In the case of testing, also inject the last stable updates
                     "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/updates/f[[ release.version_int ]]-updates/compose/Everything/$basearch/os/",
                 [% endif %]
-                # For f29 the compose location is under /compose/branched/
-                [% if release.version_int == 29 %]
+                # For f30 the compose location is going to be under /compose/branched/
+                [% if release.version_int == 30 %]
                     "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/branched/latest-Fedora-[[ release.version_int ]]/compose/Everything/$basearch/os/"
                 [% else %]
                     "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/[[ release.version_int ]]/latest-Fedora-[[ release.version_int ]]/compose/Everything/$basearch/os/"
@@ -174,8 +174,8 @@ ostree = {
                     # In the case of testing, also inject the last stable updates
                     "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/updates/f[[ release.version_int ]]-updates/compose/Everything/$basearch/os/",
                 [% endif %]
-                # For f29 the compose location is under /compose/branched/
-                [% if release.version_int == 29 %]
+                # For f30 the compose location is going to be under /compose/branched/
+                [% if release.version_int == 30 %]
                     "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/branched/latest-Fedora-[[ release.version_int ]]/compose/Everything/$basearch/os/"
                 [% else %]
                     "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/[[ release.version_int ]]/latest-Fedora-[[ release.version_int ]]/compose/Everything/$basearch/os/"
@@ -238,8 +238,8 @@ image_build = {
                 'target': 'f[[ release.version_int ]]',
                 'arches': ['x86_64', 'aarch64', 'ppc64le'],
                 'install_tree_from': 
-                    # For f29 the compose location is under /compose/branched/
-                    [% if release.version_int == 29 %]
+                    # For f30 the compose location is going to be under /compose/branched/
+                    [% if release.version_int == 30 %]
                         "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/branched/latest-Fedora-[[ release.version_int ]]/compose/Everything/$arch/os/",
                     [% else %]
                         "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/[[ release.version_int ]]/latest-Fedora-[[ release.version_int ]]/compose/Everything/$arch/os/",
@@ -271,8 +271,8 @@ image_build = {
                 'target': 'f[[ release.version_int ]]',
                 'arches': ['x86_64'],
                 'install_tree_from':
-                    # For f29 the compose location is under /compose/branched/
-                    [% if release.version_int == 29 %]
+                    # For f30 the compose location is going to be under /compose/branched/
+                    [% if release.version_int == 30 %]
                         "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/branched/latest-Fedora-[[ release.version_int ]]/compose/Everything/$arch/os/",
                     [% else %]
                         "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/[[ release.version_int ]]/latest-Fedora-[[ release.version_int ]]/compose/Everything/$arch/os/",
@@ -292,15 +292,13 @@ ostree_installer = [
         [% for arch in ['x86_64', 'aarch64', 'ppc64le'] %]
             '[[ arch ]]': {
                 "repo": [
-                    # For now we need to only provide one repo to lorax 
-                    # See https://github.com/weldr/lorax/issues/368
-                    #   "Everything",
-                    #   [% if request.name == 'testing' %]
-                    #       # In the case of testing, also inject the last stable updates
-                    #       "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/updates/f[[ release.version_int ]]-updates/compose/Everything/[[arch]]/os/",
-                    #   [% endif %]
-                    # For f29 the compose location is under /compose/branched/
-                    [% if release.version_int == 29 %]
+                    "Everything",
+                    [% if request.name == 'testing' %]
+                        # In the case of testing, also inject the last stable updates
+                        "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/updates/f[[ release.version_int ]]-updates/compose/Everything/[[arch]]/os/",
+                    [% endif %]
+                    # For f30 the compose location is going to be under /compose/branched/
+                    [% if release.version_int == 30 %]
                         "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/branched/latest-Fedora-[[ release.version_int ]]/compose/Everything/[[arch]]/os/"
                     [% else %]
                         "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/[[ release.version_int ]]/latest-Fedora-[[ release.version_int ]]/compose/Everything/[[arch]]/os/"
-- 
2.17.2